package com.test;

import javax.jms.TopicConnectionFactory;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicSubscriber;
import javax.jms.TopicSession;
import javax.jms.Message;
import javax.jms.TextMessage;
import javax.jms.JMSException;
import javax.annotation.Resource;

import javax.ejb.Stateless;


@Stateless(mappedName="ejb/TestJMSEjb")
public class TestJMSEjb implements TestJMS 
{
    @Resource(mappedName = "jms/TestTopicConnectionFactory")
    private TopicConnectionFactory topicConnectionFactory;
    @Resource(mappedName = "jms/TestTopic")
    private Topic topic;

    
	public String runTest() 
	{
        TopicConnection topicConnection = null;
        TopicSession topicSession = null;
        TopicSubscriber topicSubscriber = null;
     
        String ret = "FAILED";
        
        try 
        {
            topicConnection = topicConnectionFactory.createTopicConnection();
            topicSession = topicConnection.createTopicSession(false, TopicSession.AUTO_ACKNOWLEDGE);
            
            // ************************************************************************************
            // TopicSession.createSubscriber() fails on Glassfish V2 and V2.1 when Glassfish has
            // been configured as a cluster and the JMS service type is LOCAL or REMOTE (if the 
            // JMS Service type is EMBEDDED, it works fine).
            // ************************************************************************************
            topicSubscriber = topicSession.createSubscriber(topic);
         
            System.out.println("Create TopicSubscriber succeeded!!!!");
            
            topicConnection.start();

            Message m = topicSubscriber.receive(1000);
            
            if (m instanceof TextMessage) 
            {
                TextMessage msg = (TextMessage)m;
                System.out.println("Message = " + msg.getText());
            }
            
            ret = "PASSED";
            
        } catch (JMSException e) 
        {
            System.err.println("Exception occurred: " + e.toString());
        } 
        finally 
        {
            if (topicConnection != null) 
            {
                try 
                {
                    topicConnection.close();
                } 
                catch (JMSException e) 
                {
                }
            }
        }

        return ret;
	}

}
